package model

import "shylinux.com/x/mysql-story/src/db"

const (
	UID            = "uid"
	NAME           = "name"
	INFO           = "info"
	TYPE           = "type"
	ROLE           = "role"
	STATUS         = "status"
	TITLE          = "title"
	CONTENT        = "content"
	AVATAR         = "avatar"
	BACKGROUND     = "background"
	USER_UID       = "user_uid"
	USER_AUTH_ROLE = "user_auth_role"
	AUTH_UID       = "auth_uid"
	AUTH_NAME      = "auth_name"
	AUTH_INFO      = "auth_info"
	AUTH_TYPE      = "auth_type"
	AUTH_STATUS    = "auth_status"
	AUTH_AVATAR    = "auth_avatar"
	CERT_UID       = "cert_uid"
	PLACE_NAME     = "place_name"
	STREET_NAME    = "street_name"
	COMPANY_UID    = "company_uid"
	COMPANY_NAME   = "company_name"
	CITY_UID       = "city_uid"
	CITY_NAME      = "city_name"
	FROM_UID       = "from_uid"
	SERVICE_UID    = "service_uid"
	PLACE_UID      = "place_uid"
	STORAGE_UID    = "storage_uid"
	DASHBOARD_UID  = "dashboard_uid"
	SPACE          = "space"
	INDEX          = "index"
	PATH           = "path"
)

type UserAuth struct {
	db.ModelUserPlace
	AuthUID string `gorm:"type:char(32);index"`
}
type Auth struct {
	db.ModelNameInfo
	FromUID      string `gorm:"type:char(32);index"`
	Avatar       string `gorm:"type:varchar(255)"`
	Background   string `gorm:"type:varchar(255)"`
	ServiceUID   string `gorm:"type:char(32)"`
	PlaceUID     string `gorm:"type:char(32)"`
	StorageUID   string `gorm:"type:char(32)"`
	DashboardUID string `gorm:"type:char(32)"`
	Status       uint8  `gorm:"default:0"`
}
type Cert struct {
	db.ModelContent
	AuthUID string `gorm:"type:char(32);index"`
	Path    string `gorm:"type:varchar(255)"`
	Type    string `gorm:"type:char(8)"`
	Size    int    `gorm:"default:0"`
}

func init() { db.CmdModels("", &UserAuth{}, &Auth{}, &Cert{}) }
